"use strict";
var fs_1 = require('fs');
var path_1 = require('path');
function moduleExists(context, moduleName, extension) {
    if (/^([.\/]|[a-z]:\\)/i.test(moduleName)) {
        return load(path_1.resolve(context, moduleName), extension);
    }
    return loadNodeModule(context, moduleName, extension);
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = moduleExists;
//////////
function load(moduleName, extension) {
    return isFile(moduleName + extension) || loadDirectory(moduleName, extension);
}
function loadDirectory(moduleName, extension) {
    var main;
    try {
        main = JSON.parse(fs_1.readFileSync(path_1.join(moduleName, 'package.json')).toString()).main;
        if (main && load(path_1.resolve(moduleName, main), extension)) {
            return true;
        }
    }
    catch (e) { }
    return isFile(path_1.join(moduleName, 'index' + extension));
}
function loadNodeModule(context, moduleName, extension) {
    var directory = path_1.join(context, 'node_modules');
    while (directory) {
        if (load(path_1.join(directory, moduleName), extension)) {
            return true;
        }
        if (directory === 'node_modules') {
            break;
        }
        directory = path_1.join(path_1.dirname(path_1.dirname(directory)), 'node_modules');
    }
}
function isFile(fileName) {
    try {
        var stat = fs_1.statSync(fileName);
        return stat.isFile();
    }
    catch (e) { }
    return false;
}
